Responses
Create a model response
Creates a model response. Provide text or image inputs to generate text or JSON outputs. Have the model call your own custom code or use built-in tools like web search or file search to use your own data as input for the model’s response.
Параметры заголовка
x-ms-user-identity
string
Opaque per-user identity string used to scope endpoint-scoped data to a specific end user. The caller must have the agents/endpoints/UserIdentityImpersonation/action RBAC permission.
x-ms-session-id
string
An opaque, application-owned conversation identifier. The value is not returned in the response and must not contain secrets or personally identifiable information.
Текст запроса
metadata
OpenAI.Metadata | null
Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
user
string | null
This field is being replaced by safety_identifier and prompt_cache_key. Use prompt_cache_key instead to maintain caching optimizations. A stable identifier for your end-users. Used to boost cache hit rates by better bucketing similar requests and to help OpenAI detect and prevent abuse. Learn more.
prompt_cache_retention
enum
model
string
The model deployment to use for the creation of this response.
text
OpenAI.ResponseTextParam
Configuration options for a text response from the model. Can be plain text or structured JSON data. Learn more: - Text inputs and outputs - Structured Outputs
format
json_schema | text | json_object
An object specifying the format that the model must output. Configuring { "type": "json_schema" } enables Structured Outputs, which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide. The default format is { "type": "text" } with no additional options. Not recommended for gpt-4o and newer models:* Setting to { "type": "json_object" } enables the older JSON mode, which ensures the message the model generates is valid JSON. Using json_schema is preferred for models that support it.
json_schema
OpenAI.TextResponseFormatJsonSchema
JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
type
enum
обязательно
The type of response format being defined. Always json_schema.
description
string
A description of what the response format is for, used by the model to determine how to respond in the format.
name
string
обязательно
The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
schema
OpenAI.ResponseFormatJsonSchemaSchema
обязательно
The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
text
OpenAI.TextResponseFormatConfigurationResponseFormatText
Default response format. Used to generate text responses.
type
enum
обязательно
The type of response format being defined. Always text.
json_object
OpenAI.TextResponseFormatConfigurationResponseFormatJsonObject
JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.
type
enum
обязательно
The type of response format being defined. Always json_object.
verbosity
enum
Constrains the verbosity of the model's response. Lower values will result in more concise responses, while higher values will result in more verbose responses. Currently supported values are low, medium, and high. The default is medium.
tools
OpenAI.Tool[]
An array of tools the model may call while generating a response. You can specify which tool to use by setting the tool_choice parameter. We support the following categories of tools: - Built-in tools: Tools that are provided by OpenAI that extend the model's capabilities, like web search or file search. Learn more about built-in tools. - MCP Tools: Integrations with third-party systems via custom MCP servers or predefined connectors such as Google Drive and SharePoint. Learn more about MCP Tools. - Function calls (custom tools): Functions that are defined by you, enabling the model to call your own code with strongly typed arguments and outputs. Learn more about function calling. You can also use custom tools to call your own code.
tool_choice
enum | OpenAI.ToolChoiceParam
enum
Controls which (if any) tool is called by the model. none means the model will not call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools.
function
OpenAI.ToolChoiceFunction
Use this option to force the model to call a specific function.
type
enum
обязательно
For function calling, the type is always function.
name
string
обязательно
The name of the function to call.
mcp
OpenAI.ToolChoiceMCP
Use this option to force the model to call a specific tool on a remote MCP server.
type
enum
обязательно
For MCP tools, the type is always mcp.
server_label
string
обязательно
The label of the MCP server to use.
allowed_tools
OpenAI.ToolChoiceAllowed
Constrains the tools available to the model to a pre-defined set.
type
enum
обязательно
Allowed tool configuration type. Always allowed_tools.
mode
enum
обязательно
Constrains the tools available to the model to a pre-defined set. auto allows the model to pick from among the allowed tools and generate a message. required requires the model to call one or more of the allowed tools.
tools
object[]
обязательно
A list of tool definitions that the model should be allowed to call. For the Responses API, the list of tool definitions might look like: json [ { "type": "function", "name": "get_weather" }, { "type": "mcp", "server_label": "deepwiki" }, { "type": "image_generation" } ]
custom
OpenAI.ToolChoiceCustom
Use this option to force the model to call a specific custom tool.
type
enum
обязательно
For custom tool calling, the type is always custom.
name
string
обязательно
The name of the custom tool to call.
programmatic_tool_calling
OpenAI.SpecificProgrammaticToolCallingParam
type
enum
обязательно
The tool to call. Always programmatic_tool_calling.
apply_patch
OpenAI.SpecificApplyPatchParam
Forces the model to call the apply_patch tool when executing a tool call.
type
enum
обязательно
The tool to call. Always apply_patch.
shell
OpenAI.SpecificFunctionShellParam
Forces the model to call the shell tool when a tool call is required.
type
enum
обязательно
The tool to call. Always shell.
file_search
OpenAI.ToolChoiceFileSearch
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
web_search_preview
OpenAI.ToolChoiceWebSearchPreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
computer_use_preview
OpenAI.ToolChoiceComputerUsePreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
web_search_preview_2025_03_11
OpenAI.ToolChoiceWebSearchPreview20250311
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
image_generation
OpenAI.ToolChoiceImageGeneration
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
code_interpreter
OpenAI.ToolChoiceCodeInterpreter
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
computer
OpenAI.ToolChoiceComputer
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
computer_use
OpenAI.ToolChoiceComputerUse
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
prompt
OpenAI.Prompt
Reference to a prompt template and its variables. Learn more.
id
string
обязательно
The unique identifier of the prompt template to use.
variables
OpenAI.ResponsePromptVariables | null
Optional map of values to substitute in for variables in your prompt. The substitution values can either be strings, or other Response input types like images or files.
[key: string]
string | OpenAI.InputTextContent | OpenAI.InputImageContent | OpenAI.InputFileContent
type
enum
обязательно
The type of the input item. Always input_text.
text
string
обязательно
The text input to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
обязательно
The breakpoint mode. Always explicit.
type
enum
обязательно
The type of the input item. Always input_image.
detail
enum
обязательно
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
обязательно
The breakpoint mode. Always explicit.
type
enum
обязательно
The type of the input item. Always input_file.
filename
string
The name of the file to be sent to the model.
file_data
string
The content of the file to be sent to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
обязательно
The breakpoint mode. Always explicit.
file_url
string
The URL of the file to be sent to the model.
detail
enum
access_programs
OpenAI.AccessProgramsParam
Domain-specific access programs to use for this request.
cyber
enum
prompt_cache_options
OpenAI.ResponsePromptCacheOptionsParam
Options for prompt caching. Supported for gpt-5.6 and later models. By default, OpenAI automatically chooses one implicit cache breakpoint. You can add explicit breakpoints to content blocks with prompt_cache_breakpoint. Each request can write up to four breakpoints. For cache matching, OpenAI considers up to the latest 80 breakpoints in the conversation, without a content-block lookback limit. Set mode to explicit to disable the implicit breakpoint. The ttl defaults to 30m, which is currently the only supported value. See the prompt caching guide for current details.
ttl
enum
mode
enum
prewarm
boolean
Prepares the prompt cache without generating output. Defaults to false. When set to true, overrides the generate field to false.
service_tier
enum
Specifies the processing type used for serving the request. - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'. - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model. - If set to 'flex', then the request will be processed with the Flex Processing service tier. - To opt-in to Fast mode at the request level, include the service_tier=fast or service_tier=priority parameter for Responses or Chat Completions. The response will show service_tier=priority regardless of if you specify service_tier=fast or priority in your request. - If set to 'ultrafast', then the request will be processed with the access-controlled Ultrafast Processing service tier. This tier is currently available for gpt-5.6-sol; a response served through it will show service_tier=ultrafast. - When not set, the default behavior is 'auto'. When the service_tier parameter is set, the response body will include the service_tier value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.
truncation
enum
reasoning
OpenAI.Reasoning | null
Configuration options for reasoning models.
mode
string | enum
enum
effort
string | enum | null
Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, xhigh, and max. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response. Not all reasoning models support every value. See the reasoning guide for model-specific support.
enum
summary
enum
context
enum
generate_summary
enum
input
string | OpenAI.InputItem[]
Text, image, or file inputs to the model, used to generate a response. Learn more: - Text inputs and outputs - Image inputs - File inputs - Conversation state - Function calling
moderation
OpenAI.ModerationParam | null
Configuration for running moderation on the input and output of this response.
model
string
обязательно
The moderation model to use for moderated completions, e.g. 'omni-moderation-latest'.
policy
OpenAI.ModerationPolicyParam | null
The policy to apply to moderated response input and output.
input
OpenAI.ModerationConfigParam | null
The moderation policy for the response input.
mode
enum
обязательно
output
OpenAI.ModerationConfigParam | null
The moderation policy for the response input.
mode
enum
обязательно
stream_options
OpenAI.ResponseStreamOptions | null
Options for streaming responses. Only set this when you set stream: true.
include_obfuscation
boolean
When true, stream obfuscation will be enabled. Stream obfuscation adds random characters to an obfuscation field on streaming delta events to normalize payload sizes as a mitigation to certain side-channel attacks. These obfuscation fields are included by default, but add a small amount of overhead to the data stream. You can set include_obfuscation to false to optimize for bandwidth if you trust the network links between your application and the OpenAI API.
conversation
string | OpenAI.ConversationParam-2 | null
The conversation that this response belongs to. Items from this conversation are prepended to input_items for this response request. Input items and output items from this response are automatically added to this conversation after this response completes.
id
string
обязательно
The unique ID of the conversation.
context_management
OpenAI.ContextManagementParam[] | null
Context management configuration for this request.
agent_session_id
string
Optional session identifier for sandbox affinity. Currently only relevant for hosted agents. When provided, the request is routed to the same sandbox. When omitted, auto-derived from conversation_id/prev_response_id or a new UUID is generated.
agent_reference
AgentReference
type
enum
обязательно
name
string
обязательно
The name of the agent.
version
string
The version identifier of the agent.
structured_inputs
object
The structured inputs to the response that can participate in prompt template substitution or tool argument bindings.
user_security_context
AzureUserSecurityContext
User security context contains several parameters that describe the application itself, and the end user that interacts with the application. These fields assist your security operations teams to investigate and mitigate security incidents by providing a comprehensive approach to protecting your AI applications. Learn more about protecting AI applications using Microsoft Defender for Cloud.
application_name
string
The name of the application. Sensitive personal information should not be included in this field.
end_user_id
string
This identifier is the Microsoft Entra ID (formerly Azure Active Directory) user object ID used to authenticate end-users within the generative AI application. Sensitive personal information should not be included in this field.
end_user_tenant_id
string
The Microsoft 365 tenant ID the end user belongs to. It's required when the generative AI application is multitenant.
source_ip
string
Captures the original client's IP address.
routing_config
RoutingConfiguration
Per-request configuration for Model Router inference calls. Supported on Model Router endpoints (deployed or instant if supported). Returns a 400 (Bad Request) error when the target is not a Model Router endpoint.
session_affinity
SessionAffinityConfiguration
Request settings that control Model Router session affinity.
mode
enum
Request modes supported by Model Router session affinity.
session_id
string
An opaque, application-owned conversation identifier. Use the same value for related requests. The value is not returned in the response and must not contain secrets or personally identifiable information.
Ответы
The request has succeeded.
Заголовки
x-agent-session-id
string
Session ID for this request. Only present for hosted agent responses. Returns the provided session ID or an auto-generated one if not provided in the request.
Текст
metadata
OpenAI.Metadata | null
Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
user
string | null
This field is being replaced by safety_identifier and prompt_cache_key. Use prompt_cache_key instead to maintain caching optimizations. A stable identifier for your end-users. Used to boost cache hit rates by better bucketing similar requests and to help OpenAI detect and prevent abuse. Learn more.
prompt_cache_retention
enum
model
string
The model deployment to use for the creation of this response.
text
OpenAI.ResponseTextParam
Configuration options for a text response from the model. Can be plain text or structured JSON data. Learn more: - Text inputs and outputs - Structured Outputs
format
json_schema | text | json_object
An object specifying the format that the model must output. Configuring { "type": "json_schema" } enables Structured Outputs, which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide. The default format is { "type": "text" } with no additional options. Not recommended for gpt-4o and newer models:* Setting to { "type": "json_object" } enables the older JSON mode, which ensures the message the model generates is valid JSON. Using json_schema is preferred for models that support it.
json_schema
OpenAI.TextResponseFormatJsonSchema
JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
type
enum
обязательно
The type of response format being defined. Always json_schema.
description
string
A description of what the response format is for, used by the model to determine how to respond in the format.
name
string
обязательно
The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
schema
OpenAI.ResponseFormatJsonSchemaSchema
обязательно
The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
text
OpenAI.TextResponseFormatConfigurationResponseFormatText
Default response format. Used to generate text responses.
type
enum
обязательно
The type of response format being defined. Always text.
json_object
OpenAI.TextResponseFormatConfigurationResponseFormatJsonObject
JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.
type
enum
обязательно
The type of response format being defined. Always json_object.
verbosity
enum
Constrains the verbosity of the model's response. Lower values will result in more concise responses, while higher values will result in more verbose responses. Currently supported values are low, medium, and high. The default is medium.
tools
OpenAI.Tool[]
An array of tools the model may call while generating a response. You can specify which tool to use by setting the tool_choice parameter. We support the following categories of tools: - Built-in tools: Tools that are provided by OpenAI that extend the model's capabilities, like web search or file search. Learn more about built-in tools. - MCP Tools: Integrations with third-party systems via custom MCP servers or predefined connectors such as Google Drive and SharePoint. Learn more about MCP Tools. - Function calls (custom tools): Functions that are defined by you, enabling the model to call your own code with strongly typed arguments and outputs. Learn more about function calling. You can also use custom tools to call your own code.
tool_choice
enum | OpenAI.ToolChoiceParam
enum
Controls which (if any) tool is called by the model. none means the model will not call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools.
function
OpenAI.ToolChoiceFunction
Use this option to force the model to call a specific function.
type
enum
обязательно
For function calling, the type is always function.
name
string
обязательно
The name of the function to call.
mcp
OpenAI.ToolChoiceMCP
Use this option to force the model to call a specific tool on a remote MCP server.
type
enum
обязательно
For MCP tools, the type is always mcp.
server_label
string
обязательно
The label of the MCP server to use.
allowed_tools
OpenAI.ToolChoiceAllowed
Constrains the tools available to the model to a pre-defined set.
type
enum
обязательно
Allowed tool configuration type. Always allowed_tools.
mode
enum
обязательно
Constrains the tools available to the model to a pre-defined set. auto allows the model to pick from among the allowed tools and generate a message. required requires the model to call one or more of the allowed tools.
tools
object[]
обязательно
A list of tool definitions that the model should be allowed to call. For the Responses API, the list of tool definitions might look like: json [ { "type": "function", "name": "get_weather" }, { "type": "mcp", "server_label": "deepwiki" }, { "type": "image_generation" } ]
custom
OpenAI.ToolChoiceCustom
Use this option to force the model to call a specific custom tool.
type
enum
обязательно
For custom tool calling, the type is always custom.
name
string
обязательно
The name of the custom tool to call.
programmatic_tool_calling
OpenAI.SpecificProgrammaticToolCallingParam
type
enum
обязательно
The tool to call. Always programmatic_tool_calling.
apply_patch
OpenAI.SpecificApplyPatchParam
Forces the model to call the apply_patch tool when executing a tool call.
type
enum
обязательно
The tool to call. Always apply_patch.
shell
OpenAI.SpecificFunctionShellParam
Forces the model to call the shell tool when a tool call is required.
type
enum
обязательно
The tool to call. Always shell.
file_search
OpenAI.ToolChoiceFileSearch
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
web_search_preview
OpenAI.ToolChoiceWebSearchPreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
computer_use_preview
OpenAI.ToolChoiceComputerUsePreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
web_search_preview_2025_03_11
OpenAI.ToolChoiceWebSearchPreview20250311
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
image_generation
OpenAI.ToolChoiceImageGeneration
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
code_interpreter
OpenAI.ToolChoiceCodeInterpreter
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
computer
OpenAI.ToolChoiceComputer
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
computer_use
OpenAI.ToolChoiceComputerUse
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
prompt
OpenAI.Prompt
Reference to a prompt template and its variables. Learn more.
id
string
обязательно
The unique identifier of the prompt template to use.
variables
OpenAI.ResponsePromptVariables | null
Optional map of values to substitute in for variables in your prompt. The substitution values can either be strings, or other Response input types like images or files.
[key: string]
string | OpenAI.InputTextContent | OpenAI.InputImageContent | OpenAI.InputFileContent
type
enum
обязательно
The type of the input item. Always input_text.
text
string
обязательно
The text input to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
обязательно
The breakpoint mode. Always explicit.
type
enum
обязательно
The type of the input item. Always input_image.
detail
enum
обязательно
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
обязательно
The breakpoint mode. Always explicit.
type
enum
обязательно
The type of the input item. Always input_file.
filename
string
The name of the file to be sent to the model.
file_data
string
The content of the file to be sent to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
обязательно
The breakpoint mode. Always explicit.
file_url
string
The URL of the file to be sent to the model.
detail
enum
service_tier
enum
Specifies the processing type used for serving the request. - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'. - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model. - If set to 'flex', then the request will be processed with the Flex Processing service tier. - To opt-in to Fast mode at the request level, include the service_tier=fast or service_tier=priority parameter for Responses or Chat Completions. The response will show service_tier=priority regardless of if you specify service_tier=fast or priority in your request. - If set to 'ultrafast', then the request will be processed with the access-controlled Ultrafast Processing service tier. This tier is currently available for gpt-5.6-sol; a response served through it will show service_tier=ultrafast. - When not set, the default behavior is 'auto'. When the service_tier parameter is set, the response body will include the service_tier value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.
truncation
enum
id
string
обязательно
Unique identifier for this Response.
object
enum
обязательно
The object type of this resource - always set to response.
status
enum
The status of the response generation. One of completed, failed, in_progress, cancelled, queued, or incomplete.
access_programs
OpenAI.AccessProgramsBody | null
обязательно
cyber
enum
обязательно
created_at
integer
обязательно
Unix timestamp (in seconds) of when this Response was created.
error
OpenAI.ResponseError | null
обязательно
An error object returned when the model fails to generate a Response.
type
string | null
The original error type, or null if it was not recorded.
param
string | null
The request parameter associated with the error, or null if none was recorded.
code
enum
обязательно
The error code for the response.
message
string
обязательно
A human-readable description of the error.
misalignment
OpenAI.MisalignmentErrorDetailsResource
error_type
string | enum
enum
detailed_explanation
string
The public explanation for this block.
steer
OpenAI._MisalignmentSteer
message
string
обязательно
The public continuation instruction.
incomplete_details
OpenAI.ResponseIncompleteDetails | null
обязательно
reason
enum
output
OpenAI.OutputItem[]
обязательно
An array of content items generated by the model. - The length and order of items in the output array is dependent on the model's response. - Rather than accessing the first item in the output array and assuming it's an assistant message with the content generated by the model, you might consider using the output_text property where supported in SDKs.
reasoning
OpenAI.Reasoning | null
Configuration options for reasoning models.
mode
string | enum
enum
effort
string | enum | null
Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, xhigh, and max. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response. Not all reasoning models support every value. See the reasoning guide for model-specific support.
enum
summary
enum
context
enum
generate_summary
enum
instructions
string | OpenAI.InputItem[] | null
обязательно
usage
OpenAI.ResponseUsage | null
Represents token usage details including input tokens, output tokens, a breakdown of output tokens, and the total tokens used.
input_tokens_details
OpenAI.ResponseUsageInputTokensDetails
обязательно
output_tokens_details
OpenAI.ResponseUsageOutputTokensDetails
обязательно
prompt_cache_options
OpenAI.PromptCacheOptions
The prompt-caching options that were applied to the response. Supported for gpt-5.6 and later models.
ttl
enum
обязательно
mode
enum
обязательно
prompt_cache_diagnostics
cache_miss | cache_hit | comparison_response_not_found | unavailable
Prompt cache diagnostics requested for this response.
cache_miss
OpenAI.PromptCacheMissDiagnosticsBody
type
enum
обязательно
reason
enum
обязательно
cache_hit
OpenAI.PromptCacheHitDiagnosticsBody
type
enum
обязательно
comparison_response_not_found
OpenAI.PromptCacheComparisonResponseNotFoundDiagnosticsBody
type
enum
обязательно
unavailable
OpenAI.PromptCacheUnavailableDiagnosticsBody
type
enum
обязательно
moderation
OpenAI.Moderation | null
Moderation results or errors for the response input and output.
input
error | moderation_result
обязательно
Moderation results or an error for a response moderation check.
error
OpenAI.ModerationErrorBody
An error produced while attempting moderation for the response input or output.
type
enum
обязательно
The object type, which was always error for moderation failures.
code
string
обязательно
The error code.
message
string
обязательно
The error message.
moderation_result
OpenAI.ModerationResultBody
A moderation result produced for the response input or output.
type
enum
обязательно
The object type, which was always moderation_result for successful moderation results.
model
string
обязательно
The moderation model that produced this result.
flagged
boolean
обязательно
A boolean indicating whether the content was flagged by any category.
categories
object
обязательно
A dictionary of moderation categories to booleans, True if the input is flagged under this category.
category_scores
object
обязательно
A dictionary of moderation categories to scores.
category_applied_input_types
object
обязательно
Which modalities of input are reflected by the score for each category.
output
error | moderation_result
обязательно
Moderation results or an error for a response moderation check.
error
OpenAI.ModerationErrorBody
An error produced while attempting moderation for the response input or output.
type
enum
обязательно
The object type, which was always error for moderation failures.
code
string
обязательно
The error code.
message
string
обязательно
The error message.
moderation_result
OpenAI.ModerationResultBody
A moderation result produced for the response input or output.
type
enum
обязательно
The object type, which was always moderation_result for successful moderation results.
model
string
обязательно
The moderation model that produced this result.
flagged
boolean
обязательно
A boolean indicating whether the content was flagged by any category.
categories
object
обязательно
A dictionary of moderation categories to booleans, True if the input is flagged under this category.
category_scores
object
обязательно
A dictionary of moderation categories to scores.
category_applied_input_types
object
обязательно
Which modalities of input are reflected by the score for each category.
parallel_tool_calls
boolean
обязательно
Whether to allow the model to run tool calls in parallel.
conversation
OpenAI.ResponseConversation | null
The conversation that this response belonged to. Input items and output items from this response were automatically added to this conversation.
id
string
обязательно
The unique ID of the conversation that this response was associated with.
agent_reference
AgentReference | null
обязательно
The agent used for this response
type
enum
обязательно
name
string
обязательно
The name of the agent.
version
string
The version identifier of the agent.
model_selection_details
ModelSelectionDetails
Model selection metadata providing visibility into routing decisions.
model_router_details
ModelRouterDetails
обязательно
Routing decision metadata from Model Router.
mode
string | enum
обязательно
The routing mode used by Model Router for the request.
enum
session_affinity
SessionAffinityDetails
Effective Model Router session affinity metadata for a request.
mode
string | enum
обязательно
Effective modes reported for Model Router session affinity.
enum
source
string | enum
Conversation identifier sources supported by Model Router session affinity.
enum
decision
string | enum
Final outcomes reported for Model Router session affinity.
enum
routing_trace
RoutingTraceEntry[]
обязательно
Ordered trace of routing decisions. Contains one entry for Chat Completions, and may contain multiple entries for Responses API or agent scenarios where multiple inference turns occur.
content_filters
ContentFilterResult[]
The content filter evaluation results.
type
enum
обязательно
The type of the event. Always response.audio.delta.
delta
string
обязательно
A chunk of Base64 encoded response audio bytes.
type
enum
обязательно
The type of the event. Always response.audio.transcript.delta.
delta
string
обязательно
The partial transcript of the audio response.
type
enum
обязательно
The type of the event. Always response.code_interpreter_call_code.delta.
item_id
string
обязательно
The unique identifier of the code interpreter tool call item.
delta
string
обязательно
The partial code snippet being streamed by the code interpreter.
type
enum
обязательно
The type of the event. Always response.code_interpreter_call.in_progress.
item_id
string
обязательно
The unique identifier of the code interpreter tool call item.
type
enum
обязательно
The type of the event. Always response.code_interpreter_call.interpreting.
item_id
string
обязательно
The unique identifier of the code interpreter tool call item.
type
enum
обязательно
The type of the event. Always response.content_part.added.
item_id
string
обязательно
The ID of the output item that the content part was added to.
part
output_text | refusal | reasoning_text
обязательно
output_text
OpenAI.OutputContentOutputTextContent
A text output from the model.
type
enum
обязательно
The type of the output text. Always output_text.
text
string
обязательно
The text output from the model.
annotations
OpenAI.Annotation[]
The annotations of the text output.
refusal
OpenAI.OutputContentRefusalContent
A refusal from the model.
type
enum
обязательно
The type of the refusal. Always refusal.
refusal
string
обязательно
The refusal explanation from the model.
reasoning_text
OpenAI.OutputContentReasoningTextContent
Reasoning text from the model.
type
enum
обязательно
The type of the reasoning text. Always reasoning_text.
text
string
обязательно
The reasoning text from the model.
type
enum
обязательно
The type of the event. Always response.created.
response
OpenAI.Response
обязательно
metadata
OpenAI.Metadata | null
Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
user
string | null
This field is being replaced by safety_identifier and prompt_cache_key. Use prompt_cache_key instead to maintain caching optimizations. A stable identifier for your end-users. Used to boost cache hit rates by better bucketing similar requests and to help OpenAI detect and prevent abuse. Learn more.
prompt_cache_retention
enum
model
string
The model deployment to use for the creation of this response.
text
OpenAI.ResponseTextParam
Configuration options for a text response from the model. Can be plain text or structured JSON data. Learn more: - Text inputs and outputs - Structured Outputs
format
json_schema | text | json_object
An object specifying the format that the model must output. Configuring { "type": "json_schema" } enables Structured Outputs, which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide. The default format is { "type": "text" } with no additional options. Not recommended for gpt-4o and newer models:* Setting to { "type": "json_object" } enables the older JSON mode, which ensures the message the model generates is valid JSON. Using json_schema is preferred for models that support it.
json_schema
OpenAI.TextResponseFormatJsonSchema
JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
type
enum
обязательно
The type of response format being defined. Always json_schema.
description
string
A description of what the response format is for, used by the model to determine how to respond in the format.
name
string
обязательно
The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
schema
OpenAI.ResponseFormatJsonSchemaSchema
обязательно
The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
text
OpenAI.TextResponseFormatConfigurationResponseFormatText
Default response format. Used to generate text responses.
type
enum
обязательно
The type of response format being defined. Always text.
json_object
OpenAI.TextResponseFormatConfigurationResponseFormatJsonObject
JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.
type
enum
обязательно
The type of response format being defined. Always json_object.
verbosity
enum
Constrains the verbosity of the model's response. Lower values will result in more concise responses, while higher values will result in more verbose responses. Currently supported values are low, medium, and high. The default is medium.
tools
OpenAI.Tool[]
An array of tools the model may call while generating a response. You can specify which tool to use by setting the tool_choice parameter. We support the following categories of tools: - Built-in tools: Tools that are provided by OpenAI that extend the model's capabilities, like web search or file search. Learn more about built-in tools. - MCP Tools: Integrations with third-party systems via custom MCP servers or predefined connectors such as Google Drive and SharePoint. Learn more about MCP Tools. - Function calls (custom tools): Functions that are defined by you, enabling the model to call your own code with strongly typed arguments and outputs. Learn more about function calling. You can also use custom tools to call your own code.
tool_choice
enum | OpenAI.ToolChoiceParam
enum
Controls which (if any) tool is called by the model. none means the model will not call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools.
function
OpenAI.ToolChoiceFunction
Use this option to force the model to call a specific function.
type
enum
обязательно
For function calling, the type is always function.
name
string
обязательно
The name of the function to call.
mcp
OpenAI.ToolChoiceMCP
Use this option to force the model to call a specific tool on a remote MCP server.
type
enum
обязательно
For MCP tools, the type is always mcp.
server_label
string
обязательно
The label of the MCP server to use.
allowed_tools
OpenAI.ToolChoiceAllowed
Constrains the tools available to the model to a pre-defined set.
type
enum
обязательно
Allowed tool configuration type. Always allowed_tools.
mode
enum
обязательно
Constrains the tools available to the model to a pre-defined set. auto allows the model to pick from among the allowed tools and generate a message. required requires the model to call one or more of the allowed tools.
tools
object[]
обязательно
A list of tool definitions that the model should be allowed to call. For the Responses API, the list of tool definitions might look like: json [ { "type": "function", "name": "get_weather" }, { "type": "mcp", "server_label": "deepwiki" }, { "type": "image_generation" } ]
custom
OpenAI.ToolChoiceCustom
Use this option to force the model to call a specific custom tool.
type
enum
обязательно
For custom tool calling, the type is always custom.
name
string
обязательно
The name of the custom tool to call.
programmatic_tool_calling
OpenAI.SpecificProgrammaticToolCallingParam
type
enum
обязательно
The tool to call. Always programmatic_tool_calling.
apply_patch
OpenAI.SpecificApplyPatchParam
Forces the model to call the apply_patch tool when executing a tool call.
type
enum
обязательно
The tool to call. Always apply_patch.
shell
OpenAI.SpecificFunctionShellParam
Forces the model to call the shell tool when a tool call is required.
type
enum
обязательно
The tool to call. Always shell.
file_search
OpenAI.ToolChoiceFileSearch
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
web_search_preview
OpenAI.ToolChoiceWebSearchPreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
computer_use_preview
OpenAI.ToolChoiceComputerUsePreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
web_search_preview_2025_03_11
OpenAI.ToolChoiceWebSearchPreview20250311
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
image_generation
OpenAI.ToolChoiceImageGeneration
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
code_interpreter
OpenAI.ToolChoiceCodeInterpreter
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
computer
OpenAI.ToolChoiceComputer
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
computer_use
OpenAI.ToolChoiceComputerUse
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
prompt
OpenAI.Prompt
Reference to a prompt template and its variables. Learn more.
id
string
обязательно
The unique identifier of the prompt template to use.
variables
OpenAI.ResponsePromptVariables | null
Optional map of values to substitute in for variables in your prompt. The substitution values can either be strings, or other Response input types like images or files.
[key: string]
string | OpenAI.InputTextContent | OpenAI.InputImageContent | OpenAI.InputFileContent
type
enum
обязательно
The type of the input item. Always input_text.
text
string
обязательно
The text input to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
обязательно
The breakpoint mode. Always explicit.
type
enum
обязательно
The type of the input item. Always input_image.
detail
enum
обязательно
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
обязательно
The breakpoint mode. Always explicit.
type
enum
обязательно
The type of the input item. Always input_file.
filename
string
The name of the file to be sent to the model.
file_data
string
The content of the file to be sent to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
обязательно
The breakpoint mode. Always explicit.
file_url
string
The URL of the file to be sent to the model.
detail
enum
service_tier
enum
Specifies the processing type used for serving the request. - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'. - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model. - If set to 'flex', then the request will be processed with the Flex Processing service tier. - To opt-in to Fast mode at the request level, include the service_tier=fast or service_tier=priority parameter for Responses or Chat Completions. The response will show service_tier=priority regardless of if you specify service_tier=fast or priority in your request. - If set to 'ultrafast', then the request will be processed with the access-controlled Ultrafast Processing service tier. This tier is currently available for gpt-5.6-sol; a response served through it will show service_tier=ultrafast. - When not set, the default behavior is 'auto'. When the service_tier parameter is set, the response body will include the service_tier value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.
truncation
enum
id
string
обязательно
Unique identifier for this Response.
object
enum
обязательно
The object type of this resource - always set to response.
status
enum
The status of the response generation. One of completed, failed, in_progress, cancelled, queued, or incomplete.
access_programs
OpenAI.AccessProgramsBody | null
обязательно
cyber
enum
обязательно
created_at
integer
обязательно
Unix timestamp (in seconds) of when this Response was created.
error
OpenAI.ResponseError | null
обязательно
An error object returned when the model fails to generate a Response.
type
string | null
The original error type, or null if it was not recorded.
param
string | null
The request parameter associated with the error, or null if none was recorded.
code
enum
обязательно
The error code for the response.
message
string
обязательно
A human-readable description of the error.
misalignment
OpenAI.MisalignmentErrorDetailsResource
error_type
string | enum
enum
detailed_explanation
string
The public explanation for this block.
steer
OpenAI._MisalignmentSteer
message
string
обязательно
The public continuation instruction.
incomplete_details
OpenAI.ResponseIncompleteDetails | null
обязательно
reason
enum
output
OpenAI.OutputItem[]
обязательно
An array of content items generated by the model. - The length and order of items in the output array is dependent on the model's response. - Rather than accessing the first item in the output array and assuming it's an assistant message with the content generated by the model, you might consider using the output_text property where supported in SDKs.
reasoning
OpenAI.Reasoning | null
Configuration options for reasoning models.
mode
string | enum
enum
effort
string | enum | null
Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, xhigh, and max. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response. Not all reasoning models support every value. See the reasoning guide for model-specific support.
enum
summary
enum
context
enum
generate_summary
enum
instructions
string | OpenAI.InputItem[] | null
обязательно
usage
OpenAI.ResponseUsage | null
Represents token usage details including input tokens, output tokens, a breakdown of output tokens, and the total tokens used.
input_tokens_details
OpenAI.ResponseUsageInputTokensDetails
обязательно
output_tokens_details
OpenAI.ResponseUsageOutputTokensDetails
обязательно
prompt_cache_options
OpenAI.PromptCacheOptions
The prompt-caching options that were applied to the response. Supported for gpt-5.6 and later models.
ttl
enum
обязательно
mode
enum
обязательно
prompt_cache_diagnostics
cache_miss | cache_hit | comparison_response_not_found | unavailable
Prompt cache diagnostics requested for this response.
cache_miss
OpenAI.PromptCacheMissDiagnosticsBody
type
enum
обязательно
reason
enum
обязательно
cache_hit
OpenAI.PromptCacheHitDiagnosticsBody
type
enum
обязательно
comparison_response_not_found
OpenAI.PromptCacheComparisonResponseNotFoundDiagnosticsBody
type
enum
обязательно
unavailable
OpenAI.PromptCacheUnavailableDiagnosticsBody
type
enum
обязательно
moderation
OpenAI.Moderation | null
Moderation results or errors for the response input and output.
input
error | moderation_result
обязательно
Moderation results or an error for a response moderation check.
error
OpenAI.ModerationErrorBody
An error produced while attempting moderation for the response input or output.
type
enum
обязательно
The object type, which was always error for moderation failures.
code
string
обязательно
The error code.
message
string
обязательно
The error message.
moderation_result
OpenAI.ModerationResultBody
A moderation result produced for the response input or output.
type
enum
обязательно
The object type, which was always moderation_result for successful moderation results.
model
string
обязательно
The moderation model that produced this result.
flagged
boolean
обязательно
A boolean indicating whether the content was flagged by any category.
categories
object
обязательно
A dictionary of moderation categories to booleans, True if the input is flagged under this category.
category_scores
object
обязательно
A dictionary of moderation categories to scores.
category_applied_input_types
object
обязательно
Which modalities of input are reflected by the score for each category.
output
error | moderation_result
обязательно
Moderation results or an error for a response moderation check.
error
OpenAI.ModerationErrorBody
An error produced while attempting moderation for the response input or output.
type
enum
обязательно
The object type, which was always error for moderation failures.
code
string
обязательно
The error code.
message
string
обязательно
The error message.
moderation_result
OpenAI.ModerationResultBody
A moderation result produced for the response input or output.
type
enum
обязательно
The object type, which was always moderation_result for successful moderation results.
model
string
обязательно
The moderation model that produced this result.
flagged
boolean
обязательно
A boolean indicating whether the content was flagged by any category.
categories
object
обязательно
A dictionary of moderation categories to booleans, True if the input is flagged under this category.
category_scores
object
обязательно
A dictionary of moderation categories to scores.
category_applied_input_types
object
обязательно
Which modalities of input are reflected by the score for each category.
parallel_tool_calls
boolean
обязательно
Whether to allow the model to run tool calls in parallel.
conversation
OpenAI.ResponseConversation | null
The conversation that this response belonged to. Input items and output items from this response were automatically added to this conversation.
id
string
обязательно
The unique ID of the conversation that this response was associated with.
agent_reference
AgentReference | null
обязательно
The agent used for this response
type
enum
обязательно
name
string
обязательно
The name of the agent.
version
string
The version identifier of the agent.
model_selection_details
ModelSelectionDetails
Model selection metadata providing visibility into routing decisions.
model_router_details
ModelRouterDetails
обязательно
Routing decision metadata from Model Router.
mode
string | enum
обязательно
The routing mode used by Model Router for the request.
enum
session_affinity
SessionAffinityDetails
Effective Model Router session affinity metadata for a request.
mode
string | enum
обязательно
Effective modes reported for Model Router session affinity.
enum
source
string | enum
Conversation identifier sources supported by Model Router session affinity.
enum
decision
string | enum
Final outcomes reported for Model Router session affinity.
enum
routing_trace
RoutingTraceEntry[]
обязательно
Ordered trace of routing decisions. Contains one entry for Chat Completions, and may contain multiple entries for Responses API or agent scenarios where multiple inference turns occur.
content_filters
ContentFilterResult[]
The content filter evaluation results.
type
enum
обязательно
The type of the event. Always error.
message
string
обязательно
The error message.
type
enum
обязательно
The type of the event. Always response.file_search_call.in_progress.
item_id
string
обязательно
The ID of the output item that the file search call is initiated.
type
enum
обязательно
The type of the event. Always response.file_search_call.searching.
item_id
string
обязательно
The ID of the output item that the file search call is initiated.
type
enum
обязательно
The type of the event. Always response.function_call_arguments.delta.
item_id
string
обязательно
The ID of the output item that the function-call arguments delta is added to.
delta
string
обязательно
The function-call arguments delta that is added.
type
enum
обязательно
The type of the event. Always response.in_progress.
response
OpenAI.Response
обязательно
metadata
OpenAI.Metadata | null
Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
user
string | null
This field is being replaced by safety_identifier and prompt_cache_key. Use prompt_cache_key instead to maintain caching optimizations. A stable identifier for your end-users. Used to boost cache hit rates by better bucketing similar requests and to help OpenAI detect and prevent abuse. Learn more.
prompt_cache_retention
enum
model
string
The model deployment to use for the creation of this response.
text
OpenAI.ResponseTextParam
Configuration options for a text response from the model. Can be plain text or structured JSON data. Learn more: - Text inputs and outputs - Structured Outputs
format
json_schema | text | json_object
An object specifying the format that the model must output. Configuring { "type": "json_schema" } enables Structured Outputs, which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide. The default format is { "type": "text" } with no additional options. Not recommended for gpt-4o and newer models:* Setting to { "type": "json_object" } enables the older JSON mode, which ensures the message the model generates is valid JSON. Using json_schema is preferred for models that support it.
json_schema
OpenAI.TextResponseFormatJsonSchema
JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
type
enum
обязательно
The type of response format being defined. Always json_schema.
description
string
A description of what the response format is for, used by the model to determine how to respond in the format.
name
string
обязательно
The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
schema
OpenAI.ResponseFormatJsonSchemaSchema
обязательно
The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
text
OpenAI.TextResponseFormatConfigurationResponseFormatText
Default response format. Used to generate text responses.
type
enum
обязательно
The type of response format being defined. Always text.
json_object
OpenAI.TextResponseFormatConfigurationResponseFormatJsonObject
JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.
type
enum
обязательно
The type of response format being defined. Always json_object.
verbosity
enum
Constrains the verbosity of the model's response. Lower values will result in more concise responses, while higher values will result in more verbose responses. Currently supported values are low, medium, and high. The default is medium.
tools
OpenAI.Tool[]
An array of tools the model may call while generating a response. You can specify which tool to use by setting the tool_choice parameter. We support the following categories of tools: - Built-in tools: Tools that are provided by OpenAI that extend the model's capabilities, like web search or file search. Learn more about built-in tools. - MCP Tools: Integrations with third-party systems via custom MCP servers or predefined connectors such as Google Drive and SharePoint. Learn more about MCP Tools. - Function calls (custom tools): Functions that are defined by you, enabling the model to call your own code with strongly typed arguments and outputs. Learn more about function calling. You can also use custom tools to call your own code.
tool_choice
enum | OpenAI.ToolChoiceParam
enum
Controls which (if any) tool is called by the model. none means the model will not call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools.
function
OpenAI.ToolChoiceFunction
Use this option to force the model to call a specific function.
type
enum
обязательно
For function calling, the type is always function.
name
string
обязательно
The name of the function to call.
mcp
OpenAI.ToolChoiceMCP
Use this option to force the model to call a specific tool on a remote MCP server.
type
enum
обязательно
For MCP tools, the type is always mcp.
server_label
string
обязательно
The label of the MCP server to use.
allowed_tools
OpenAI.ToolChoiceAllowed
Constrains the tools available to the model to a pre-defined set.
type
enum
обязательно
Allowed tool configuration type. Always allowed_tools.
mode
enum
обязательно
Constrains the tools available to the model to a pre-defined set. auto allows the model to pick from among the allowed tools and generate a message. required requires the model to call one or more of the allowed tools.
tools
object[]
обязательно
A list of tool definitions that the model should be allowed to call. For the Responses API, the list of tool definitions might look like: json [ { "type": "function", "name": "get_weather" }, { "type": "mcp", "server_label": "deepwiki" }, { "type": "image_generation" } ]
custom
OpenAI.ToolChoiceCustom
Use this option to force the model to call a specific custom tool.
type
enum
обязательно
For custom tool calling, the type is always custom.
name
string
обязательно
The name of the custom tool to call.
programmatic_tool_calling
OpenAI.SpecificProgrammaticToolCallingParam
type
enum
обязательно
The tool to call. Always programmatic_tool_calling.
apply_patch
OpenAI.SpecificApplyPatchParam
Forces the model to call the apply_patch tool when executing a tool call.
type
enum
обязательно
The tool to call. Always apply_patch.
shell
OpenAI.SpecificFunctionShellParam
Forces the model to call the shell tool when a tool call is required.
type
enum
обязательно
The tool to call. Always shell.
file_search
OpenAI.ToolChoiceFileSearch
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
web_search_preview
OpenAI.ToolChoiceWebSearchPreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
computer_use_preview
OpenAI.ToolChoiceComputerUsePreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
web_search_preview_2025_03_11
OpenAI.ToolChoiceWebSearchPreview20250311
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
image_generation
OpenAI.ToolChoiceImageGeneration
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
code_interpreter
OpenAI.ToolChoiceCodeInterpreter
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
computer
OpenAI.ToolChoiceComputer
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
computer_use
OpenAI.ToolChoiceComputerUse
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
prompt
OpenAI.Prompt
Reference to a prompt template and its variables. Learn more.
id
string
обязательно
The unique identifier of the prompt template to use.
variables
OpenAI.ResponsePromptVariables | null
Optional map of values to substitute in for variables in your prompt. The substitution values can either be strings, or other Response input types like images or files.
[key: string]
string | OpenAI.InputTextContent | OpenAI.InputImageContent | OpenAI.InputFileContent
type
enum
обязательно
The type of the input item. Always input_text.
text
string
обязательно
The text input to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
обязательно
The breakpoint mode. Always explicit.
type
enum
обязательно
The type of the input item. Always input_image.
detail
enum
обязательно
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
обязательно
The breakpoint mode. Always explicit.
type
enum
обязательно
The type of the input item. Always input_file.
filename
string
The name of the file to be sent to the model.
file_data
string
The content of the file to be sent to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
обязательно
The breakpoint mode. Always explicit.
file_url
string
The URL of the file to be sent to the model.
detail
enum
service_tier
enum
Specifies the processing type used for serving the request. - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'. - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model. - If set to 'flex', then the request will be processed with the Flex Processing service tier. - To opt-in to Fast mode at the request level, include the service_tier=fast or service_tier=priority parameter for Responses or Chat Completions. The response will show service_tier=priority regardless of if you specify service_tier=fast or priority in your request. - If set to 'ultrafast', then the request will be processed with the access-controlled Ultrafast Processing service tier. This tier is currently available for gpt-5.6-sol; a response served through it will show service_tier=ultrafast. - When not set, the default behavior is 'auto'. When the service_tier parameter is set, the response body will include the service_tier value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.
truncation
enum
id
string
обязательно
Unique identifier for this Response.
object
enum
обязательно
The object type of this resource - always set to response.
status
enum
The status of the response generation. One of completed, failed, in_progress, cancelled, queued, or incomplete.
access_programs
OpenAI.AccessProgramsBody | null
обязательно
cyber
enum
обязательно
created_at
integer
обязательно
Unix timestamp (in seconds) of when this Response was created.
error
OpenAI.ResponseError | null
обязательно
An error object returned when the model fails to generate a Response.
type
string | null
The original error type, or null if it was not recorded.
param
string | null
The request parameter associated with the error, or null if none was recorded.
code
enum
обязательно
The error code for the response.
message
string
обязательно
A human-readable description of the error.
misalignment
OpenAI.MisalignmentErrorDetailsResource
error_type
string | enum
enum
detailed_explanation
string
The public explanation for this block.
steer
OpenAI._MisalignmentSteer
message
string
обязательно
The public continuation instruction.
incomplete_details
OpenAI.ResponseIncompleteDetails | null
обязательно
reason
enum
output
OpenAI.OutputItem[]
обязательно
An array of content items generated by the model. - The length and order of items in the output array is dependent on the model's response. - Rather than accessing the first item in the output array and assuming it's an assistant message with the content generated by the model, you might consider using the output_text property where supported in SDKs.
reasoning
OpenAI.Reasoning | null
Configuration options for reasoning models.
mode
string | enum
enum
effort
string | enum | null
Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, xhigh, and max. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response. Not all reasoning models support every value. See the reasoning guide for model-specific support.
enum
summary
enum
context
enum
generate_summary
enum
instructions
string | OpenAI.InputItem[] | null
обязательно
usage
OpenAI.ResponseUsage | null
Represents token usage details including input tokens, output tokens, a breakdown of output tokens, and the total tokens used.
input_tokens_details
OpenAI.ResponseUsageInputTokensDetails
обязательно
output_tokens_details
OpenAI.ResponseUsageOutputTokensDetails
обязательно
prompt_cache_options
OpenAI.PromptCacheOptions
The prompt-caching options that were applied to the response. Supported for gpt-5.6 and later models.
ttl
enum
обязательно
mode
enum
обязательно
prompt_cache_diagnostics
cache_miss | cache_hit | comparison_response_not_found | unavailable
Prompt cache diagnostics requested for this response.
cache_miss
OpenAI.PromptCacheMissDiagnosticsBody
type
enum
обязательно
reason
enum
обязательно
cache_hit
OpenAI.PromptCacheHitDiagnosticsBody
type
enum
обязательно
comparison_response_not_found
OpenAI.PromptCacheComparisonResponseNotFoundDiagnosticsBody
type
enum
обязательно
unavailable
OpenAI.PromptCacheUnavailableDiagnosticsBody
type
enum
обязательно
moderation
OpenAI.Moderation | null
Moderation results or errors for the response input and output.
input
error | moderation_result
обязательно
Moderation results or an error for a response moderation check.
error
OpenAI.ModerationErrorBody
An error produced while attempting moderation for the response input or output.
type
enum
обязательно
The object type, which was always error for moderation failures.
code
string
обязательно
The error code.
message
string
обязательно
The error message.
moderation_result
OpenAI.ModerationResultBody
A moderation result produced for the response input or output.
type
enum
обязательно
The object type, which was always moderation_result for successful moderation results.
model
string
обязательно
The moderation model that produced this result.
flagged
boolean
обязательно
A boolean indicating whether the content was flagged by any category.
categories
object
обязательно
A dictionary of moderation categories to booleans, True if the input is flagged under this category.
category_scores
object
обязательно
A dictionary of moderation categories to scores.
category_applied_input_types
object
обязательно
Which modalities of input are reflected by the score for each category.
output
error | moderation_result
обязательно
Moderation results or an error for a response moderation check.
error
OpenAI.ModerationErrorBody
An error produced while attempting moderation for the response input or output.
type
enum
обязательно
The object type, which was always error for moderation failures.
code
string
обязательно
The error code.
message
string
обязательно
The error message.
moderation_result
OpenAI.ModerationResultBody
A moderation result produced for the response input or output.
type
enum
обязательно
The object type, which was always moderation_result for successful moderation results.
model
string
обязательно
The moderation model that produced this result.
flagged
boolean
обязательно
A boolean indicating whether the content was flagged by any category.
categories
object
обязательно
A dictionary of moderation categories to booleans, True if the input is flagged under this category.
category_scores
object
обязательно
A dictionary of moderation categories to scores.
category_applied_input_types
object
обязательно
Which modalities of input are reflected by the score for each category.
parallel_tool_calls
boolean
обязательно
Whether to allow the model to run tool calls in parallel.
conversation
OpenAI.ResponseConversation | null
The conversation that this response belonged to. Input items and output items from this response were automatically added to this conversation.
id
string
обязательно
The unique ID of the conversation that this response was associated with.
agent_reference
AgentReference | null
обязательно
The agent used for this response
type
enum
обязательно
name
string
обязательно
The name of the agent.
version
string
The version identifier of the agent.
model_selection_details
ModelSelectionDetails
Model selection metadata providing visibility into routing decisions.
model_router_details
ModelRouterDetails
обязательно
Routing decision metadata from Model Router.
mode
string | enum
обязательно
The routing mode used by Model Router for the request.
enum
session_affinity
SessionAffinityDetails
Effective Model Router session affinity metadata for a request.
mode
string | enum
обязательно
Effective modes reported for Model Router session affinity.
enum
source
string | enum
Conversation identifier sources supported by Model Router session affinity.
enum
decision
string | enum
Final outcomes reported for Model Router session affinity.
enum
routing_trace
RoutingTraceEntry[]
обязательно
Ordered trace of routing decisions. Contains one entry for Chat Completions, and may contain multiple entries for Responses API or agent scenarios where multiple inference turns occur.
content_filters
ContentFilterResult[]
The content filter evaluation results.
type
enum
обязательно
The type of the event. Always response.failed.
response
OpenAI.Response
обязательно
metadata
OpenAI.Metadata | null
Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
user
string | null
This field is being replaced by safety_identifier and prompt_cache_key. Use prompt_cache_key instead to maintain caching optimizations. A stable identifier for your end-users. Used to boost cache hit rates by better bucketing similar requests and to help OpenAI detect and prevent abuse. Learn more.
prompt_cache_retention
enum
model
string
The model deployment to use for the creation of this response.
text
OpenAI.ResponseTextParam
Configuration options for a text response from the model. Can be plain text or structured JSON data. Learn more: - Text inputs and outputs - Structured Outputs
format
json_schema | text | json_object
An object specifying the format that the model must output. Configuring { "type": "json_schema" } enables Structured Outputs, which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide. The default format is { "type": "text" } with no additional options. Not recommended for gpt-4o and newer models:* Setting to { "type": "json_object" } enables the older JSON mode, which ensures the message the model generates is valid JSON. Using json_schema is preferred for models that support it.
json_schema
OpenAI.TextResponseFormatJsonSchema
JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
type
enum
обязательно
The type of response format being defined. Always json_schema.
description
string
A description of what the response format is for, used by the model to determine how to respond in the format.
name
string
обязательно
The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
schema
OpenAI.ResponseFormatJsonSchemaSchema
обязательно
The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
text
OpenAI.TextResponseFormatConfigurationResponseFormatText
Default response format. Used to generate text responses.
type
enum
обязательно
The type of response format being defined. Always text.
json_object
OpenAI.TextResponseFormatConfigurationResponseFormatJsonObject
JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.
type
enum
обязательно
The type of response format being defined. Always json_object.
verbosity
enum
Constrains the verbosity of the model's response. Lower values will result in more concise responses, while higher values will result in more verbose responses. Currently supported values are low, medium, and high. The default is medium.
tools
OpenAI.Tool[]
An array of tools the model may call while generating a response. You can specify which tool to use by setting the tool_choice parameter. We support the following categories of tools: - Built-in tools: Tools that are provided by OpenAI that extend the model's capabilities, like web search or file search. Learn more about built-in tools. - MCP Tools: Integrations with third-party systems via custom MCP servers or predefined connectors such as Google Drive and SharePoint. Learn more about MCP Tools. - Function calls (custom tools): Functions that are defined by you, enabling the model to call your own code with strongly typed arguments and outputs. Learn more about function calling. You can also use custom tools to call your own code.
tool_choice
enum | OpenAI.ToolChoiceParam
enum
Controls which (if any) tool is called by the model. none means the model will not call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools.
function
OpenAI.ToolChoiceFunction
Use this option to force the model to call a specific function.
type
enum
обязательно
For function calling, the type is always function.
name
string
обязательно
The name of the function to call.
mcp
OpenAI.ToolChoiceMCP
Use this option to force the model to call a specific tool on a remote MCP server.
type
enum
обязательно
For MCP tools, the type is always mcp.
server_label
string
обязательно
The label of the MCP server to use.
allowed_tools
OpenAI.ToolChoiceAllowed
Constrains the tools available to the model to a pre-defined set.
type
enum
обязательно
Allowed tool configuration type. Always allowed_tools.
mode
enum
обязательно
Constrains the tools available to the model to a pre-defined set. auto allows the model to pick from among the allowed tools and generate a message. required requires the model to call one or more of the allowed tools.
tools
object[]
обязательно
A list of tool definitions that the model should be allowed to call. For the Responses API, the list of tool definitions might look like: json [ { "type": "function", "name": "get_weather" }, { "type": "mcp", "server_label": "deepwiki" }, { "type": "image_generation" } ]
custom
OpenAI.ToolChoiceCustom
Use this option to force the model to call a specific custom tool.
type
enum
обязательно
For custom tool calling, the type is always custom.
name
string
обязательно
The name of the custom tool to call.
programmatic_tool_calling
OpenAI.SpecificProgrammaticToolCallingParam
type
enum
обязательно
The tool to call. Always programmatic_tool_calling.
apply_patch
OpenAI.SpecificApplyPatchParam
Forces the model to call the apply_patch tool when executing a tool call.
type
enum
обязательно
The tool to call. Always apply_patch.
shell
OpenAI.SpecificFunctionShellParam
Forces the model to call the shell tool when a tool call is required.
type
enum
обязательно
The tool to call. Always shell.
file_search
OpenAI.ToolChoiceFileSearch
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
web_search_preview
OpenAI.ToolChoiceWebSearchPreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
computer_use_preview
OpenAI.ToolChoiceComputerUsePreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
web_search_preview_2025_03_11
OpenAI.ToolChoiceWebSearchPreview20250311
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
image_generation
OpenAI.ToolChoiceImageGeneration
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
code_interpreter
OpenAI.ToolChoiceCodeInterpreter
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
computer
OpenAI.ToolChoiceComputer
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
computer_use
OpenAI.ToolChoiceComputerUse
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
prompt
OpenAI.Prompt
Reference to a prompt template and its variables. Learn more.
id
string
обязательно
The unique identifier of the prompt template to use.
variables
OpenAI.ResponsePromptVariables | null
Optional map of values to substitute in for variables in your prompt. The substitution values can either be strings, or other Response input types like images or files.
[key: string]
string | OpenAI.InputTextContent | OpenAI.InputImageContent | OpenAI.InputFileContent
type
enum
обязательно
The type of the input item. Always input_text.
text
string
обязательно
The text input to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
обязательно
The breakpoint mode. Always explicit.
type
enum
обязательно
The type of the input item. Always input_image.
detail
enum
обязательно
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
обязательно
The breakpoint mode. Always explicit.
type
enum
обязательно
The type of the input item. Always input_file.
filename
string
The name of the file to be sent to the model.
file_data
string
The content of the file to be sent to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
обязательно
The breakpoint mode. Always explicit.
file_url
string
The URL of the file to be sent to the model.
detail
enum
service_tier
enum
Specifies the processing type used for serving the request. - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'. - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model. - If set to 'flex', then the request will be processed with the Flex Processing service tier. - To opt-in to Fast mode at the request level, include the service_tier=fast or service_tier=priority parameter for Responses or Chat Completions. The response will show service_tier=priority regardless of if you specify service_tier=fast or priority in your request. - If set to 'ultrafast', then the request will be processed with the access-controlled Ultrafast Processing service tier. This tier is currently available for gpt-5.6-sol; a response served through it will show service_tier=ultrafast. - When not set, the default behavior is 'auto'. When the service_tier parameter is set, the response body will include the service_tier value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.
truncation
enum
id
string
обязательно
Unique identifier for this Response.
object
enum
обязательно
The object type of this resource - always set to response.
status
enum
The status of the response generation. One of completed, failed, in_progress, cancelled, queued, or incomplete.
access_programs
OpenAI.AccessProgramsBody | null
обязательно
cyber
enum
обязательно
created_at
integer
обязательно
Unix timestamp (in seconds) of when this Response was created.
error
OpenAI.ResponseError | null
обязательно
An error object returned when the model fails to generate a Response.
type
string | null
The original error type, or null if it was not recorded.
param
string | null
The request parameter associated with the error, or null if none was recorded.
code
enum
обязательно
The error code for the response.
message
string
обязательно
A human-readable description of the error.
misalignment
OpenAI.MisalignmentErrorDetailsResource
error_type
string | enum
enum
detailed_explanation
string
The public explanation for this block.
steer
OpenAI._MisalignmentSteer
message
string
обязательно
The public continuation instruction.
incomplete_details
OpenAI.ResponseIncompleteDetails | null
обязательно
reason
enum
output
OpenAI.OutputItem[]
обязательно
An array of content items generated by the model. - The length and order of items in the output array is dependent on the model's response. - Rather than accessing the first item in the output array and assuming it's an assistant message with the content generated by the model, you might consider using the output_text property where supported in SDKs.
reasoning
OpenAI.Reasoning | null
Configuration options for reasoning models.
mode
string | enum
enum
effort
string | enum | null
Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, xhigh, and max. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response. Not all reasoning models support every value. See the reasoning guide for model-specific support.
enum
summary
enum
context
enum
generate_summary
enum
instructions
string | OpenAI.InputItem[] | null
обязательно
usage
OpenAI.ResponseUsage | null
Represents token usage details including input tokens, output tokens, a breakdown of output tokens, and the total tokens used.
input_tokens_details
OpenAI.ResponseUsageInputTokensDetails
обязательно
output_tokens_details
OpenAI.ResponseUsageOutputTokensDetails
обязательно
prompt_cache_options
OpenAI.PromptCacheOptions
The prompt-caching options that were applied to the response. Supported for gpt-5.6 and later models.
ttl
enum
обязательно
mode
enum
обязательно
prompt_cache_diagnostics
cache_miss | cache_hit | comparison_response_not_found | unavailable
Prompt cache diagnostics requested for this response.
cache_miss
OpenAI.PromptCacheMissDiagnosticsBody
type
enum
обязательно
reason
enum
обязательно
cache_hit
OpenAI.PromptCacheHitDiagnosticsBody
type
enum
обязательно
comparison_response_not_found
OpenAI.PromptCacheComparisonResponseNotFoundDiagnosticsBody
type
enum
обязательно
unavailable
OpenAI.PromptCacheUnavailableDiagnosticsBody
type
enum
обязательно
moderation
OpenAI.Moderation | null
Moderation results or errors for the response input and output.
input
error | moderation_result
обязательно
Moderation results or an error for a response moderation check.
error
OpenAI.ModerationErrorBody
An error produced while attempting moderation for the response input or output.
type
enum
обязательно
The object type, which was always error for moderation failures.
code
string
обязательно
The error code.
message
string
обязательно
The error message.
moderation_result
OpenAI.ModerationResultBody
A moderation result produced for the response input or output.
type
enum
обязательно
The object type, which was always moderation_result for successful moderation results.
model
string
обязательно
The moderation model that produced this result.
flagged
boolean
обязательно
A boolean indicating whether the content was flagged by any category.
categories
object
обязательно
A dictionary of moderation categories to booleans, True if the input is flagged under this category.
category_scores
object
обязательно
A dictionary of moderation categories to scores.
category_applied_input_types
object
обязательно
Which modalities of input are reflected by the score for each category.
output
error | moderation_result
обязательно
Moderation results or an error for a response moderation check.
error
OpenAI.ModerationErrorBody
An error produced while attempting moderation for the response input or output.
type
enum
обязательно
The object type, which was always error for moderation failures.
code
string
обязательно
The error code.
message
string
обязательно
The error message.
moderation_result
OpenAI.ModerationResultBody
A moderation result produced for the response input or output.
type
enum
обязательно
The object type, which was always moderation_result for successful moderation results.
model
string
обязательно
The moderation model that produced this result.
flagged
boolean
обязательно
A boolean indicating whether the content was flagged by any category.
categories
object
обязательно
A dictionary of moderation categories to booleans, True if the input is flagged under this category.
category_scores
object
обязательно
A dictionary of moderation categories to scores.
category_applied_input_types
object
обязательно
Which modalities of input are reflected by the score for each category.
parallel_tool_calls
boolean
обязательно
Whether to allow the model to run tool calls in parallel.
conversation
OpenAI.ResponseConversation | null
The conversation that this response belonged to. Input items and output items from this response were automatically added to this conversation.
id
string
обязательно
The unique ID of the conversation that this response was associated with.
agent_reference
AgentReference | null
обязательно
The agent used for this response
type
enum
обязательно
name
string
обязательно
The name of the agent.
version
string
The version identifier of the agent.
model_selection_details
ModelSelectionDetails
Model selection metadata providing visibility into routing decisions.
model_router_details
ModelRouterDetails
обязательно
Routing decision metadata from Model Router.
mode
string | enum
обязательно
The routing mode used by Model Router for the request.
enum
session_affinity
SessionAffinityDetails
Effective Model Router session affinity metadata for a request.
mode
string | enum
обязательно
Effective modes reported for Model Router session affinity.
enum
source
string | enum
Conversation identifier sources supported by Model Router session affinity.
enum
decision
string | enum
Final outcomes reported for Model Router session affinity.
enum
routing_trace
RoutingTraceEntry[]
обязательно
Ordered trace of routing decisions. Contains one entry for Chat Completions, and may contain multiple entries for Responses API or agent scenarios where multiple inference turns occur.
content_filters
ContentFilterResult[]
The content filter evaluation results.
type
enum
обязательно
The type of the event. Always response.incomplete.
response
OpenAI.Response
обязательно
metadata
OpenAI.Metadata | null
Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
user
string | null
This field is being replaced by safety_identifier and prompt_cache_key. Use prompt_cache_key instead to maintain caching optimizations. A stable identifier for your end-users. Used to boost cache hit rates by better bucketing similar requests and to help OpenAI detect and prevent abuse. Learn more.
prompt_cache_retention
enum
model
string
The model deployment to use for the creation of this response.
text
OpenAI.ResponseTextParam
Configuration options for a text response from the model. Can be plain text or structured JSON data. Learn more: - Text inputs and outputs - Structured Outputs
format
json_schema | text | json_object
An object specifying the format that the model must output. Configuring { "type": "json_schema" } enables Structured Outputs, which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide. The default format is { "type": "text" } with no additional options. Not recommended for gpt-4o and newer models:* Setting to { "type": "json_object" } enables the older JSON mode, which ensures the message the model generates is valid JSON. Using json_schema is preferred for models that support it.
json_schema
OpenAI.TextResponseFormatJsonSchema
JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
type
enum
обязательно
The type of response format being defined. Always json_schema.
description
string
A description of what the response format is for, used by the model to determine how to respond in the format.
name
string
обязательно
The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
schema
OpenAI.ResponseFormatJsonSchemaSchema
обязательно
The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
text
OpenAI.TextResponseFormatConfigurationResponseFormatText
Default response format. Used to generate text responses.
type
enum
обязательно
The type of response format being defined. Always text.
json_object
OpenAI.TextResponseFormatConfigurationResponseFormatJsonObject
JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.
type
enum
обязательно
The type of response format being defined. Always json_object.
verbosity
enum
Constrains the verbosity of the model's response. Lower values will result in more concise responses, while higher values will result in more verbose responses. Currently supported values are low, medium, and high. The default is medium.
tools
OpenAI.Tool[]
An array of tools the model may call while generating a response. You can specify which tool to use by setting the tool_choice parameter. We support the following categories of tools: - Built-in tools: Tools that are provided by OpenAI that extend the model's capabilities, like web search or file search. Learn more about built-in tools. - MCP Tools: Integrations with third-party systems via custom MCP servers or predefined connectors such as Google Drive and SharePoint. Learn more about MCP Tools. - Function calls (custom tools): Functions that are defined by you, enabling the model to call your own code with strongly typed arguments and outputs. Learn more about function calling. You can also use custom tools to call your own code.
tool_choice
enum | OpenAI.ToolChoiceParam
enum
Controls which (if any) tool is called by the model. none means the model will not call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools.
function
OpenAI.ToolChoiceFunction
Use this option to force the model to call a specific function.
type
enum
обязательно
For function calling, the type is always function.
name
string
обязательно
The name of the function to call.
mcp
OpenAI.ToolChoiceMCP
Use this option to force the model to call a specific tool on a remote MCP server.
type
enum
обязательно
For MCP tools, the type is always mcp.
server_label
string
обязательно
The label of the MCP server to use.
allowed_tools
OpenAI.ToolChoiceAllowed
Constrains the tools available to the model to a pre-defined set.
type
enum
обязательно
Allowed tool configuration type. Always allowed_tools.
mode
enum
обязательно
Constrains the tools available to the model to a pre-defined set. auto allows the model to pick from among the allowed tools and generate a message. required requires the model to call one or more of the allowed tools.
tools
object[]
обязательно
A list of tool definitions that the model should be allowed to call. For the Responses API, the list of tool definitions might look like: json [ { "type": "function", "name": "get_weather" }, { "type": "mcp", "server_label": "deepwiki" }, { "type": "image_generation" } ]
custom
OpenAI.ToolChoiceCustom
Use this option to force the model to call a specific custom tool.
type
enum
обязательно
For custom tool calling, the type is always custom.
name
string
обязательно
The name of the custom tool to call.
programmatic_tool_calling
OpenAI.SpecificProgrammaticToolCallingParam
type
enum
обязательно
The tool to call. Always programmatic_tool_calling.
apply_patch
OpenAI.SpecificApplyPatchParam
Forces the model to call the apply_patch tool when executing a tool call.
type
enum
обязательно
The tool to call. Always apply_patch.
shell
OpenAI.SpecificFunctionShellParam
Forces the model to call the shell tool when a tool call is required.
type
enum
обязательно
The tool to call. Always shell.
file_search
OpenAI.ToolChoiceFileSearch
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
web_search_preview
OpenAI.ToolChoiceWebSearchPreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
computer_use_preview
OpenAI.ToolChoiceComputerUsePreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
web_search_preview_2025_03_11
OpenAI.ToolChoiceWebSearchPreview20250311
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
image_generation
OpenAI.ToolChoiceImageGeneration
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
code_interpreter
OpenAI.ToolChoiceCodeInterpreter
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
computer
OpenAI.ToolChoiceComputer
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
computer_use
OpenAI.ToolChoiceComputerUse
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
type
enum
обязательно
prompt
OpenAI.Prompt
Reference to a prompt template and its variables. Learn more.
id
string
обязательно
The unique identifier of the prompt template to use.
variables
OpenAI.ResponsePromptVariables | null
Optional map of values to substitute in for variables in your prompt. The substitution values can either be strings, or other Response input types like images or files.
[key: string]
string | OpenAI.InputTextContent | OpenAI.InputImageContent | OpenAI.InputFileContent
type
enum
обязательно
The type of the input item. Always input_text.
text
string
обязательно
The text input to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
обязательно
The breakpoint mode. Always explicit.
type
enum
обязательно
The type of the input item. Always input_image.
detail
enum
обязательно
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.
mode
enum
обязательно
The breakpoint mode. Always explicit.
type
enum
обязательно
The type of the input item. Always input_file.
filename
string
The name of the file to be sent to the model.
file_data
string
The content of the file to be sent to the model.
prompt_cache_breakpoint
OpenAI.PromptCacheBreakpointConfig
[...]
